#include <avr/io.h>
#include <avr/interrupt.h>

void init_UART (void)
{
	UBRRL = 103; //9600 bps @ 16 MHz crystal
	UCSRB = _BV(RXEN)|_BV(RXCIE); //EX enable, RX int enable
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0); //n,8,1
}

ISR(USART_RXC_vect) {
	uint8_t data = UDR;
	if (data=='a') {
		PORTA |= _BV(PINA0);
	}
	if (data=='b') {
		PORTA &= ~_BV(PINA0);
	}
}

int main() {
	init_UART();
	sei();
	DDRA = _BV(DDA0);
	for(;;);
}
