﻿#include <avr/io.h>

void init_Timer() {
	TCCR1B = _BV(CS11)|_BV(CS10); //clk/64
}

void init_UART() {
	UCSRB = _BV(RXEN)|_BV(TXEN)|_BV(RXCIE); //EX enable, RX int enable
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0); //n,8,1
}

void sendByte(uint8_t data) {
	while(!(UCSRA & _BV(UDRE)));
	UDR = data;
}			

int main() {
	init_Timer();
	init_UART();
	while(PIND & _BV(PIND0));
	TCNT1 = 0;
	while(!(PIND & _BV(PIND0)));
	uint16_t i = TCNT1;
	i >>= 1;
	i--;
	UBRRL = i;
	UBRRH = i >> 8;
	sendByte('O');
	sendByte('K');
	sendByte('\n');
    while(1);
}
