#include <avr/io.h>
#define F_CPU 16000000U
#include <util/delay.h>

void init_UART (void)
{
	UBRRL = 103; //9600 bps @ 16 MHz crystal
	UCSRB = _BV(TXEN); //TX enable
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0); //n,8,1
}

int main() {
	uint8_t state;
	uint8_t stateOld = 3;
	PORTA |= _BV(PINA1);
	init_UART();
	for(;;) {
		state = PINA & _BV(PINA1);
		if (state!=stateOld) {
			stateOld = state;
			while(!(UCSRA & _BV(UDRE)));
			if(state==0) UDR = 'P'; else UDR = 'N';
			_delay_ms(50);
		}
	}
}
