#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000U
#include <util/delay.h>

volatile uint8_t state;

void init_UART (void)
{
	UBRRL = 103; //9600 bps @ 16 MHz crystal
	UCSRB = _BV(RXEN)|_BV(TXEN)|_BV(RXCIE); //EX enable, RX int enable
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0); //n,8,1
}

ISR(USART_RXC_vect) {
	uint8_t data = UDR;
	if (data=='a') {
		PORTA |= _BV(PINA0);
	}
	if (data=='b') {
		PORTA &= ~_BV(PINA0);
	}
	if (data=='r') {
		while(!(UCSRA & _BV(UDRE)));
		if(state==0) UDR = 'P'; else UDR = 'N';
	}
}

int main() {
	uint8_t stateOld = 3;
	init_UART();
	sei();
	DDRA |= _BV(DDA0);
	PORTA |= _BV(PINA1);
	for(;;) {
		state = PINA & _BV(PINA1);
		if (state!=stateOld) {
			stateOld = state;
			while(!(UCSRA & _BV(UDRE)));
			if(state==0) UDR = 'P'; else UDR = 'N';
			_delay_ms(50);
		}
	}
}
