#include <avr/io.h>
#include <avr/interrupt.h>

volatile uint8_t dispUsart = 0;
volatile uint8_t dispTimer = 0;
volatile uint8_t digits[4];
volatile uint16_t timeout = 0;

void init_UART() {
	UBRRL = 103;
	UCSRB = _BV(RXEN)|_BV(RXCIE);
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0);
}

void init_Timer() {
	TIMSK = _BV(TOIE0);               // Int T0 Overflow enabled
	TCCR0 = _BV(CS00)|_BV(CS01);      // CLK/64
}

ISR(TIMER0_OVF_vect)
{ 
	PORTB = ~_BV(dispTimer);
	PORTA = ~digits[dispTimer];
	dispTimer++;
	if (dispTimer==4) dispTimer = 0;
	timeout++;
	if (timeout > 1000) dispUsart = 0;
}

ISR(USART_RXC_vect) {
	uint8_t data = UDR;
	digits[dispUsart] = data;
	dispUsart++;
	if (dispUsart==4) dispUsart = 0;
	timeout = 0;
}

int main(void) 
{ 
	DDRA = 0xff;
	DDRB = 0x0f;
	init_UART();
	init_Timer();
	sei();
	while(1) {
	}
}
