#include <avr/io.h>
#include <avr/interrupt.h>

void init_Timer() {
	TCCR0 = _BV(WGM01)|_BV(WGM00)|_BV(COM01)|_BV(CS00);  // Fast PWM Mode, CLK/1
	DDRB = _BV(DDB3);
}

void init_UART(void)
{
	UBRRL = 103; //9600 bps @ 16 MHz crystal
	UCSRB = _BV(RXEN)|_BV(RXCIE); //EX enable, RX int enable
	UCSRC = _BV(URSEL)|_BV(UCSZ1)|_BV(UCSZ0); //n,8,1
}

ISR(USART_RXC_vect) {
	OCR0 = UDR;
}

int main() {
	init_Timer();
	init_UART();
	sei();
	OCR0 = 0;
	while(1);
	return 0;
}
